# Build Guide

## 部品
### 必須
| 名前 | 数 | 備考 | 
|:-|:-|:-|
| PCB | 2枚 | |
| トッププレート | 2枚 | |
| ボトムプレート | 2枚 | PCBタイプとアクリルタイプが選べます |
| ProMicro保護プレート | 2枚 | |
| ProMicro | 2枚 | |
| TRRSジャック | 2個 | |
| タクトスイッチ | 2個 | |
| ダイオード | 42本 | チップ部品のみに対応 |
| Kailh PCBソケット | 42個 | |
| キースイッチ | 42個 | CherryMX互換にのみ対応 |
| キーキャップ | 42個 | 1u 40個、1.5u 2個 |
| OLEDモジュール | 2枚 | |
| ピンヘッダ 4連 | 2つ | |
| ピンソケット4連 | 2つ | |
| スペーサー M2 6.5mm | 10本 | |
| スペーサー M2 8mm | 4本 | |
| ネジ M2 4mm | 28本 | |
| クッションゴム | 8個 | |
| TRS(3極)ケーブル | 1本 | TRRS(4極)ケーブルでも可 |
| Micro USBケーブル | 1本 | |

### オプション
| 名前 | 数 | 備考 |
|:-|:-|:-|
| SK6812MINI | 54個 | 上向き実装 42個、下向き実装 12個 |

![01](https://user-images.githubusercontent.com/736191/46775572-c3202700-cd42-11e8-8097-9daa71bccc98.JPG)

## 実装

PCBはリバーシブルになっているので、最初にどちらを左用/右用にするか決めます。

![02](https://user-images.githubusercontent.com/736191/46775606-024e7800-cd43-11e8-8792-90b0c3c9d060.JPG)

### ダイオード

チップ部品のダイオードのはんだづけを行います。
どちらの面に取り付けるかは自由ですが、このビルドガイドでは裏面に取り付けていきます。

チップ部品は非常に小さいためピンセット及び逆作用ピンセットがあると作業がしやすくなります。
__ダイオードは取り付ける向きが決まっている__ので、次の写真のように予め取り付ける列と行、ダイオードの向きを揃えて配置しておくとスムーズに進められます。

![03](https://user-images.githubusercontent.com/736191/46775611-04b0d200-cd43-11e8-8f73-919256c0064d.JPG)

ダイオードの向きは次のとおりです。チップ部品の「|||」印が、ダイオードマーク「|◁」の「|」の方に向けるように取り付けます。 

![04](https://user-images.githubusercontent.com/736191/46775614-08dcef80-cd43-11e8-907c-7fc853d06b8b.JPG)

チップ部品を取り付けるコツですが、まずは予備ハンダとしてパッドの右側のみにハンダを盛ります。

![05](https://user-images.githubusercontent.com/736191/46775615-09758600-cd43-11e8-9fa4-c78af441bb6f.JPG)

次に予備ハンダを溶かすようにしてダイオードの片足をはんだ付けします。
このとき、逆作用ピンセットを利用すると力を入れずともチップ部品をしっかりと持つことができ、位置合わせとはんだづけに集中できるのでおすすめです。
またはんだごてがあつすぎたり、はんだを触りすぎたりするとはんだに含まれるフラックスが気化してきれいにはんだの山ができることがありますが、あとで修復できるのでこの時点ではパーツを付けることだけを意識すれば大丈夫です。

![06](https://user-images.githubusercontent.com/736191/46775616-09758600-cd43-11e8-9cc5-c4f5e49dc578.JPG)

片足をつけた段階で横から見てダイオードが浮いていなければ大丈夫です。浮いてしまった場合はダイオードをピンセットや指で押さえつけながらはんだごてではんだづけした部分を再度熱すればきれいになります。

![07](https://user-images.githubusercontent.com/736191/46775618-09758600-cd43-11e8-8305-83972952d307.JPG)

次にもう片方をはんだづけします。少量のはんだで十分なのでつけすぎに注意します。
つけすぎてしまった場合は吸い取り線で取るか、はんだごてですくうようにすれば取れます。

また予備はんだ側のはんだの量が少ない場合は追加ではんだづけを重ねて行い、山になっている場合はフラックスを上から塗って熱すればきれいになります。

![08](https://user-images.githubusercontent.com/736191/46776208-93bee980-cd45-11e8-82e2-db25e1070ef4.JPG)

### TRRSジャック、リセットスイッチ

下記の写真通りにTRRSジャック、リセットスイッチをPCBの表面にはんだづけします。
このビルドガイドではダイオードを裏側につけているので、その反対側の面になります。

![09](https://user-images.githubusercontent.com/736191/46775620-0a0e1c80-cd43-11e8-92b4-99a3d63caa16.JPG)

### OLEDモジュールのためのジャンパとピンソケット
OLEDモジュールを利用する場合は下記のようにジャンパします。
なお__表面のみジャンパしてください__。

ピンソケットも同じ面にはんだづけします。

![10](https://user-images.githubusercontent.com/736191/46775621-0a0e1c80-cd43-11e8-9ef3-c5c01879eb90.JPG)

ジャンパがうまくいかない場合はおそらくはんだの量が少ないか、はんだに含まれるフラックスが気化してしまっています。
その場合は、はんだを多めに使うか、別途フラックスを塗るとうまくジャンパができます。

### ProMicro
ピンヘッダを白い枠に当てはめるようにはんだづけし、そこにProMicroの裏面を上にしてはんだづけします。

![11](https://user-images.githubusercontent.com/736191/46775622-0a0e1c80-cd43-11e8-9910-49b81db92c02.JPG)
![12](https://user-images.githubusercontent.com/736191/46775623-0aa6b300-cd43-11e8-826c-d6422070ddea.JPG)

### OLEDモジュール
OLED用のピンソケットにピンヘッダを先に差し込み、その後からピンヘッダとOLEDモジュールをはんだづけします。
このときOLEDモジュールが浮きやすいので指で押さえつけながら浮かないように気をつけます。

![13](https://user-images.githubusercontent.com/736191/46775624-0aa6b300-cd43-11e8-8f83-7acc5e0a407c.JPG)
![14](https://user-images.githubusercontent.com/736191/46775627-0aa6b300-cd43-11e8-8849-ba0d776692e3.JPG)

### 動作確認
ProMicroとOLEDモジュールを付けた段階で動作確認をすることをおすすめします(一番最後にやると問題の切り分けが難しくなる)。

動作確認をする場合は先に下記の「ファームウェア」の章を参考にしてcrkbd用のファームウェアをProMicroに入れてください（必ず両側に入れてください）。

動作確認は左手側はMicroUSBでPCとつなぎ、左手側と右手側をTRSケーブルで接続させて行います。ジャック等の不良等もありえるので、片方ずつではなく必ず左右を接続させてから動作確認をしてください。ここまで正しくできていれば、PCBソケットを取り付けるパッドをピンセット等でショートさせるとOLEDモジュールに押されたキーが表示されます。

![15](https://user-images.githubusercontent.com/736191/46775628-0b3f4980-cd43-11e8-96d1-59b20da62e5b.JPG)

### Kailh PCBソケット
裏面の両側のパッドにはんだを盛ります。後から追加するのが難しいので予め多めに持ってください。

![16](https://user-images.githubusercontent.com/736191/46775629-0b3f4980-cd43-11e8-83e2-ca51572f95d0.JPG)

ソケットをはめこみ、持ったはんだを溶かすようにして取り付けます。
このときソケットが浮かないようにピンセットや指で押さえつけながら行います。

![17](https://user-images.githubusercontent.com/736191/46775631-0b3f4980-cd43-11e8-9542-1cc8677782dd.JPG)

はんだづけはこれで完了です。
オプションでLEDを付ける場合は下記の「LED」の章を参照してください（ソケットを取り付けた後でも付けれられます）。

![18](https://user-images.githubusercontent.com/736191/46775632-0b3f4980-cd43-11e8-89a2-dda788a3e35b.JPG)

### プレート、スイッチ

先にスイッチをトッププレートにはめこみます。
あとからでもいいですが、スイッチのはめこみは多少ちからを入れる必要があるので、先にはめておいたほうが楽です。

![20](https://user-images.githubusercontent.com/736191/46775633-0bd7e000-cd43-11e8-9dc8-f66a0c14a258.JPG)

最後にトッププレート、PCB、ボトムプレートの順になるように、ネジでスペーサを取り付けて、四隅にクッションゴムを取り付ければ完成です。

![21](https://user-images.githubusercontent.com/736191/46775634-0bd7e000-cd43-11e8-9523-54ebc370aa37.JPG)

## ファームウェア
https://docs.qmk.fm/#/newbs_getting_started こちらを参照して頂き、ファームウェアを書き込む環境を用意します。

環境ができましたら、下記コマンドで Let's Split 用にファームウェアをビルドします。

```
make crkbd:default
```

ビルドが完了したら下記コマンドを実行します。

```
make crkbd:default:avrdude
```

実行すると下記のようなログがでて、`.` が増えていくことが確認出来ると思います。
この間にリセットスイッチを __2回__ 押すとファームウェアの書き込みが完了します。

```
<省略>

Checking file size of crkbd_rev1_default.hex                                                        [OK]
 * File size is fine - 27328/28672
Copying crkbd_rev1_default.hex to qmk_firmware folder                                               [OK]
Detecting USB port, reset your controller now........
```

片側のProMicroにファームウェアの書き込みが完了したら、もう片方も同じ手順で書き込みを行います。

以上で完成です。

## LED（オプション）
SK6812MINIを取り付けていきます。

SK6812MINIは非常に熱に弱く、簡単に壊れます。
温調機能がついたはんだごてを利用し、220℃ ~ 270℃ぐらいの温度で作業することをおすすめします。
また温度を調整しても長い時間コテをLEDに当てていると破損するので、なるべくすばやくはんだづけすることを心がけます。
LEDは４つずつはんだづけを行いますが、一度に４つ行わず、２つずつ行ってLEDの温度の上昇を防ぐと破損しづらくなるのでおすすめです。

まずは取り付ける位置の確認です。

1 ~ 6は裏面側(Undergrow)が光るようにし、7 ~ 27は表側（Backlight）が光るようにはんだづけを行います。下記がLEDを取り付ける位置です。

![23](https://user-images.githubusercontent.com/736191/46822561-c6f58d00-cdc6-11e8-90d4-de015410a7a4.png)
![24](https://user-images.githubusercontent.com/736191/46822569-cc52d780-cdc6-11e8-9602-f6265a2c876d.png)

1 ~ 6 は下記のように丸印で囲った黒い部分を下にしたとき、矢印で示したシルクの目印が上になるようにはんだづけを行います。
1 ~ 3 と 4 ~ 5 で向きが変わるので注意してください。

![26](https://user-images.githubusercontent.com/736191/46822428-6d8d5e00-cdc6-11e8-8858-06e8dbdb8ee8.png)

7 ~ 27 は下記のように、丸印で囲った一番大きなパッドと、矢印で示したシルクの目印が隣り合うようにはんだづけを行います。

![30](https://user-images.githubusercontent.com/736191/46822434-6ebe8b00-cdc6-11e8-9686-69ac88bb4389.png)

すべて正常にはんだづけができれば下記のように光ります。
もし途中までしか光らない場合は数字の順番でLEDがつながっているので、光らないLEDもしくはその前のLEDのはんだづけミスやLEDの破損を疑ってください。

![31](https://user-images.githubusercontent.com/736191/46822435-6ebe8b00-cdc6-11e8-892b-dc785fede9ea.JPG)

これで完成です。

![32](https://user-images.githubusercontent.com/736191/46822437-6ebe8b00-cdc6-11e8-8754-aa3438a2eb7b.JPG)

